/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/FilterStyle'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./FilterStyle'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.RegistryInfo = factory(root.HarborApi.ApiClient, root.HarborApi.FilterStyle);
  }
}(this, function(ApiClient, FilterStyle) {
  'use strict';

  /**
   * The RegistryInfo model module.
   * @module model/RegistryInfo
   * @version 2.0
   */

  /**
   * Constructs a new <code>RegistryInfo</code>.
   * The registry info contains the base info and capability declarations of the registry
   * @alias module:model/RegistryInfo
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>RegistryInfo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RegistryInfo} obj Optional instance to populate.
   * @return {module:model/RegistryInfo} The populated <code>RegistryInfo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('type'))
        obj.type = ApiClient.convertToType(data['type'], 'String');
      if (data.hasOwnProperty('description'))
        obj.description = ApiClient.convertToType(data['description'], 'String');
      if (data.hasOwnProperty('supported_resource_filters'))
        obj.supportedResourceFilters = ApiClient.convertToType(data['supported_resource_filters'], [FilterStyle]);
      if (data.hasOwnProperty('supported_triggers'))
        obj.supportedTriggers = ApiClient.convertToType(data['supported_triggers'], ['String']);
    }
    return obj;
  }

  /**
   * The registry type
   * @member {String} type
   */
  exports.prototype.type = undefined;

  /**
   * The description
   * @member {String} description
   */
  exports.prototype.description = undefined;

  /**
   * The filters that the registry supports
   * @member {Array.<module:model/FilterStyle>} supportedResourceFilters
   */
  exports.prototype.supportedResourceFilters = undefined;

  /**
   * The triggers that the registry supports
   * @member {Array.<String>} supportedTriggers
   */
  exports.prototype.supportedTriggers = undefined;


  return exports;

}));
